%define with_maven 1
Name:          oscache
Version:       2.4.1
Release:       %mkrel 1
Summary:       High performance J2EE caching solution
Group:         Development/Java
License:       ASL 2.0
Url:           http://www.opensymphony.com/oscache/
# svn export http://svn.opensymphony.com/svn/oscache/tags/v2_4_1 oscache-2.4.1
# tar czf oscache-2.4.1.tar.gz oscache-2.4.1
Source0:       oscache-2.4.1.tar.gz
Source1:       oscache-2.4.1-osbuild.xml
Source2:       oscache-2.4.1-ivyconf.xml
Source3:       oscache-2.4.1-ivy.xml
Source4:       oscache-2.4.1-depmap
Patch0:        oscache-2.4.1-no-clover.patch
Patch1:        oscache-2.4.1-no-groboutils.patch
Patch2:        oscache-2.4.1-pom_xml.patch


BuildRequires: java-devel
BuildRequires: jpackage-utils

%if !%with_maven
BuildRequires: ant
BuildRequires: ant-junit
BuildRequires: ant-trax
BuildRequires: ivy
%else
BuildRequires: maven
BuildRequires: maven-changes-plugin
BuildRequires: maven-compiler-plugin
BuildRequires: maven-idea-plugin
BuildRequires: maven-jar-plugin
BuildRequires: maven-javadoc-plugin
BuildRequires: maven-plugin-cobertura
BuildRequires: maven-project-info-reports-plugin
BuildRequires: maven-site-plugin
BuildRequires: maven-source-plugin
BuildRequires: maven-surefire-report-plugin
%endif
BuildRequires: apache-commons-logging
BuildRequires: geronimo-jms
BuildRequires: hibernate3
BuildRequires: httpunit
BuildRequires: jgroups
# TODO add pom
BuildRequires: junit
BuildRequires: junitperf
BuildRequires: servletapi4

Requires:      apache-commons-logging

Requires:      java
Requires:      jpackage-utils
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
BuildArch:     noarch

%description
OSCache solves fundamental problems for dynamic websites:
+ Caching Dynamic Content - Dynamic content must often be
executed in some form each request, but sometimes that
content doesn't change every request. Caching the whole
page does not help because sections of the page change
every request. OSCache solves this problem by providing
a means to cache sections of JSP pages.
+ Caching Binary Content - Generated images and PDFs can
be very costly in terms of server load. OSCache solves
this problem through a Servlet 2.3 CachingFilter which
can cache any URI (such as an entire page or a generated
image/PDF)
+ Error Tolerance - If one error occurs somewhere on your
dynamic page, chances are the whole page will be returned
as an error, even if 95%% of the page executed correctly.
OSCache solves this problem by allowing you to serve the
cached content in the event of an error, and then
reporting the error appropriately.

%package javadoc
Summary:       Javadocs for %{name}
Group:         Development/Java
Requires:      jpackage-utils

%description javadoc
This package contains the API documentation for %{name}.

%prep
%setup -q -n oscache-%{version}

find \( -name '*.jar' -o -name '*.class' -o -name '*.bat' \) -exec rm -f '{}' \;
# req GroboUtils
rm src/test/java/com/opensymphony/oscache/base/TestConcurrency2.java

cp -p %{SOURCE1} osbuild.xml
cp -p %{SOURCE2} ivyconf.xml
cp -p %{SOURCE3} ivy.xml

cp -p trunk/ivyconf.properties ivyconf.properties
touch EMPTY.MF

%patch0 -p1
%patch1 -p1
%patch2 -p0


sed -i "s|<artifactId>hibernate|<artifactId>hibernate-core|" pom.xml

%build

%if !%with_maven
  sed -i "s|fr.jayasoft.ivy.ant|org.apache.ivy.ant|" build.xml
  export CLASSPATH=$(build-classpath ivy ant/ant-junit junit ant/ant-trax)
  ant -Dcommon.build=osbuild.xml -Divy.available=true jar docs example-war 
%else
# TODO  X test rebuild junit with new macro
  mvn-rpmbuild \
    -e \
    -Dmaven.local.depmap.file=%{SOURCE4} \
    -Dmaven.test.skip=true \
    install javadoc:aggregate
%endif

%install
[ %{buildroot} != / ] && rm -rf %{buildroot}

mkdir -p %{buildroot}%{_javadir}
mkdir -p %{buildroot}%{_javadocdir}/%{name}
%if !%with_maven
  install -m 644 build/%{name}-%{version}.jar %{buildroot}%{_javadir}/
  cp -pr dist/docs/api/* %{buildroot}%{_javadocdir}/%{name}
  rm -rf dist/docs/api
%else
  install -m 644 target/%{name}-%{version}.jar %{buildroot}%{_javadir}/
  cp -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}
%endif

(
  cd %{buildroot}%{_javadir}
  for jar in *-%{version}*; do
    ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`
  done
)

mkdir -p %{buildroot}%{_mavenpomdir}
install -m 644 pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{name}.pom
%add_maven_depmap JPP-%{name}.pom %{name}.jar

%clean
[ %{buildroot} != / ] && rm -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%{_javadir}/%{name}-%{version}.jar
%{_javadir}/%{name}.jar
%{_mavenpomdir}/*
%{_mavendepmapfragdir}/*
%doc LICENSE.txt readme.txt
%if !%with_maven
%doc dist/docs dist/oscache-example.war
%endif

%files javadoc
%{_javadocdir}/%{name}


%changelog

* Wed Oct 26 2011 gil <gil> 2.4.1-1.mga2
+ Revision: 158325
- imported package oscache

